export declare class AsyncWrapper<T> implements AsyncIterable<T> {
    protected iterable: AsyncIterable<T>;
    constructor(iterable: AsyncIterable<T>);
    [Symbol.asyncIterator](): AsyncIterator<T>;
    map<U>(mapFunc: (value: T) => U): AsyncWrapper<U>;
    mapAwait<U>(mapFunc: (value: T) => Promise<U>): AsyncWrapper<U>;
}
