import { AsyncWrapper } from "./async-wrapper";
export declare class Wrapper<T> implements Iterable<T> {
    protected iterable: Iterable<T>;
    constructor(iterable: Iterable<T>);
    [Symbol.iterator](): Iterator<T>;
    map<U>(mapFunc: (value: T) => U): Wrapper<U>;
    mapAwait<U>(mapFunc: (value: T) => Promise<U>): AsyncWrapper<U>;
}
