"use strict";
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __await = (this && this.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }
var __asyncGenerator = (this && this.__asyncGenerator) || function (thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
    function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var async_wrapper_1 = require("./async-wrapper");
var Wrapper = (function () {
    function Wrapper(iterable) {
        this.iterable = iterable;
    }
    Wrapper.prototype[Symbol.iterator] = function () {
        return this.iterable[Symbol.iterator]();
    };
    Wrapper.prototype.map = function (mapFunc) {
        return new Wrapper((function (values) {
            var e_1, _a, values_1, values_1_1, value, e_1_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 5, 6, 7]);
                        values_1 = __values(values), values_1_1 = values_1.next();
                        _b.label = 1;
                    case 1:
                        if (!!values_1_1.done) return [3, 4];
                        value = values_1_1.value;
                        return [4, mapFunc(value)];
                    case 2:
                        _b.sent();
                        _b.label = 3;
                    case 3:
                        values_1_1 = values_1.next();
                        return [3, 1];
                    case 4: return [3, 7];
                    case 5:
                        e_1_1 = _b.sent();
                        e_1 = { error: e_1_1 };
                        return [3, 7];
                    case 6:
                        try {
                            if (values_1_1 && !values_1_1.done && (_a = values_1.return)) _a.call(values_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7];
                    case 7: return [2];
                }
            });
        })(this.iterable));
    };
    Wrapper.prototype.mapAwait = function (mapFunc) {
        return new async_wrapper_1.AsyncWrapper((function (values) {
            return __asyncGenerator(this, arguments, function () {
                var e_2, _a, values_2, values_2_1, value, e_2_1;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _b.trys.push([0, 7, 8, 9]);
                            values_2 = __values(values), values_2_1 = values_2.next();
                            _b.label = 1;
                        case 1:
                            if (!!values_2_1.done) return [3, 6];
                            value = values_2_1.value;
                            return [4, __await(mapFunc(value))];
                        case 2: return [4, __await.apply(void 0, [_b.sent()])];
                        case 3: return [4, _b.sent()];
                        case 4:
                            _b.sent();
                            _b.label = 5;
                        case 5:
                            values_2_1 = values_2.next();
                            return [3, 1];
                        case 6: return [3, 9];
                        case 7:
                            e_2_1 = _b.sent();
                            e_2 = { error: e_2_1 };
                            return [3, 9];
                        case 8:
                            try {
                                if (values_2_1 && !values_2_1.done && (_a = values_2.return)) _a.call(values_2);
                            }
                            finally { if (e_2) throw e_2.error; }
                            return [7];
                        case 9: return [2];
                    }
                });
            });
        })(this.iterable));
    };
    return Wrapper;
}());
exports.Wrapper = Wrapper;
